'*************************************************************************
'
'  Licensed to the Apache Software Foundation (ASF) under one
'  or more contributor license agreements.  See the NOTICE file
'  distributed with this work for additional information
'  regarding copyright ownership.  The ASF licenses this file
'  to you under the Apache License, Version 2.0 (the
'  "License"); you may not use this file except in compliance
'  with the License.  You may obtain a copy of the License at
'  
'    http://www.apache.org/licenses/LICENSE-2.0
'  
'  Unless required by applicable law or agreed to in writing,
'  software distributed under the License is distributed on an
'  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
'  KIND, either express or implied.  See the License for the
'  specific language governing permissions and limitations
'  under the License.
'
'*************************************************************************

Option Explicit On
Option Strict On

imports System	
imports System.Collections
imports Microsoft.VisualBasic
imports unoidl.com.sun.star.frame
imports unoidl.com.sun.star.lang
imports unoidl.com.sun.star.uno
imports unoidl.com.sun.star.bridge
imports uno.util

Module WriterDemo

Sub Main( ByVal args() As String)

Dim xContext As XComponentContext
xContext = Bootstrap.bootstrap()

Dim xFactory As XMultiServiceFactory 
xFactory = DirectCast(xContext.getServiceManager(), XMultiServiceFactory)


Dim xDesktop As unoidl.com.sun.star.frame.XDesktop
xDesktop = DirectCast( _
	xFactory.createInstance("com.sun.star.frame.Desktop"), _
    unoidl.com.sun.star.frame.XDesktop)

Dim xComponentLoader As unoidl.com.sun.star.frame.XComponentLoader
xComponentLoader = DirectCast( _
	xDesktop, _
	unoidl.com.sun.star.frame.XComponentLoader)

Dim arProps() As unoidl.com.sun.star.beans.PropertyValue = _
    New unoidl.com.sun.star.beans.PropertyValue(){ _
		new unoidl.com.sun.star.beans.PropertyValue( _
			"Hidden",  _
			-1,  _
			New uno.Any( True ),  _
			unoidl.com.sun.star.beans.PropertyState.DIRECT_VALUE ) }

Dim xComponent As unoidl.com.sun.star.lang.XComponent
xComponent = xComponentLoader.loadComponentFromURL( _
   "private:factory/swriter", _
   "_blank", _
   unoidl.com.sun.star.frame.FrameSearchFlag.ALL, _
   arProps)

Dim xTextDocument As unoidl.com.sun.star.text.XTextDocument
xTextDocument = DirectCast(xComponent, unoidl.com.sun.star.text.XTextDocument)

Dim xText As unoidl.com.sun.star.text.XText
xText = xTextDocument.getText()

Dim xTextRange As unoidl.com.sun.star.text.XTextRange
xTextRange = DirectCast(xText, unoidl.com.sun.star.text.XTextRange)
xTextRange.setString("Dummy text")

Dim xStorable As unoidl.com.sun.star.frame.XStorable
xStorable = DirectCast(xComponent, unoidl.com.sun.star.frame.XStorable)

Dim aMediaDescriptor() As unoidl.com.sun.star.beans.PropertyValue = _
    New unoidl.com.sun.star.beans.PropertyValue(){ _
		new unoidl.com.sun.star.beans.PropertyValue( _
			"FilterName",  _
			-1,  _
			New uno.Any( "writer_pdf_Export" ),  _
			unoidl.com.sun.star.beans.PropertyState.DIRECT_VALUE ) }

Dim xPathSubst As unoidl.com.sun.star.util.XStringSubstitution
xPathSubst = DirectCast( _
	xFactory.createInstance("com.sun.star.util.PathSubstitution"), _
    unoidl.com.sun.star.util.XStringSubstitution)

Dim sURL as String
sURL = xPathSubst.getSubstituteVariableValue("$(home)") + "/HiddenTest.pdf"

Console.WriteLine()
Console.WriteLine("Document exported as " + sURL)
Console.WriteLine()

xStorable.storeToURL(sURL, aMediaDescriptor)

Dim xCloseable As unoidl.com.sun.star.util.XCloseable
xCloseable = DirectCast(xComponent, unoidl.com.sun.star.util.XCloseable)
xCloseable.close(True)

Console.Write("Press ENTER to finish the example")
Console.ReadLine()

End Sub


End Module
